// FilesManager.cpp : implementation file
//

#include "stdafx.h"
#include "SyncDir.h"
#include "FilesManager.h"

static const UINT UDM_SET_NOTIFY_TEXT = RegisterWindowMessage(_T("UDM_SET_NOTIFY_TEXT"));

// CFilesManager

IMPLEMENT_DYNAMIC(CFilesManager, CWnd)

CFilesManager::CFilesManager()
{

}

CFilesManager::~CFilesManager()
{
}


BEGIN_MESSAGE_MAP(CFilesManager, CWnd)
END_MESSAGE_MAP()


// CFilesManager message handlers


//================================================================================
// Clase del monitor de cambios en el directorio a Sincronizar.
// basado en el cdigo implementada por DavidCrow,
// http://www.codeproject.com/KB/system/FolderWatch.aspx
//================================================================================
class CFileWatcher 
{
public:

    CString strFolder;
    HANDLE hEvent;
    HWND hWnd;
    BOOL bSubfolders;

    const CFileWatcher& operator=( const CFileWatcher *pSrc )
    {
        strFolder   = pSrc->strFolder;
        hEvent      = pSrc->hEvent;
        hWnd        = pSrc->hWnd;
        bSubfolders = pSrc->bSubfolders;
		return *this;
    }
};

typedef CFileWatcher *PFileWatcher;

void CFilesManager::CreateMonitoringThread( CString m_sFolder )
{
    m_event.ResetEvent(); // Reseteo de Eventos

    PFileWatcher pFileWatcher  = new CFileWatcher;
    pFileWatcher->hEvent      = m_event.m_hObject;
    pFileWatcher->hWnd        = m_hWnd;
    pFileWatcher->bSubfolders = true;
    pFileWatcher->strFolder = m_sFolder;

    CWinThread* pWinThread = AfxBeginThread(ThreadFunc, pFileWatcher, THREAD_PRIORITY_IDLE);

    pWinThread->m_bAutoDelete = FALSE;
    m_pWinThread = pWinThread;
}
//================================================================================
//================================================================================

/* static */ UINT CFilesManager::ThreadFunc( LPVOID pParam )
{
    CFileWatcher FileWatcher;
	
    FileWatcher = (PFileWatcher) pParam;
    delete (PFileWatcher) pParam;

    // Obtener un HANDLE del objeto de notificacin del cambio.
    HANDLE hChange = FindFirstChangeNotification(FileWatcher.strFolder,
                                                 FileWatcher.bSubfolders, 
                                                 FILE_NOTIFY_CHANGE_FILE_NAME+FILE_NOTIFY_CHANGE_DIR_NAME+FILE_NOTIFY_CHANGE_ATTRIBUTES+
												 FILE_NOTIFY_CHANGE_SIZE+FILE_NOTIFY_CHANGE_SECURITY);

    if (INVALID_HANDLE_VALUE == hChange)
        return 1;

    HANDLE aHandles[2];
    aHandles[0] = hChange;
    aHandles[1] = FileWatcher.hEvent;

    // sleep until a file change notification wakes this thread or
    // m_event becomes set indicating it's time for the thread to end.
    BOOL bContinue = TRUE;
    while (bContinue)
    {
        if (WaitForMultipleObjects(2, aHandles, FALSE, INFINITE) - WAIT_OBJECT_0 == 0)
        {
            CString *pstrText = new CString(FileWatcher.strFolder);
            ::PostMessage(FileWatcher.hWnd, UDM_SET_NOTIFY_TEXT, 0, (LPARAM) pstrText);
			AfxMessageBox(_T("Ocurri un cambio"));

            FindNextChangeNotification(hChange);
        }
	}

    FindCloseChangeNotification(hChange);

    return 0;
}

//====================================================================

